/* **************************************************************************** 
  This file is part of the kde-game 'kjumpingCube'

  Copyright (C) 1998 by Matthias Kiefer <Matthias.Kiefer@stud.uni-karlsruhe.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  *******************************************************************************/  


#ifndef Cube_H
#define Cube_H

#include <qframe.h>


class QPalette;
class CubeSim;
/**
* This class represents a Cube
*/
class Cube : public QFrame
{
    Q_OBJECT
public:
   Cube(QWidget *parent=0,int row=0,int column=0,const char *name=0,int max_Value=0);
    ~Cube();
    void setMaxValue(int);
    void setOwner(int);
    void setValue(int);
    int getOwner();
    int getMaxValue();
    int value();
    void increase(int player);
    void decrease();
    int maxReached();
    void showTip();
    
    Cube& operator=(CubeSim); 
            
    static void allowClicks(bool);
    static void setColors(QPalette *player1, QPalette *player2);
    static int playerPoints[2];

public slots:   
    void reset();
    void updateColor();
    void hideTip();
    
signals:
    void cubeClicked(int row,int column);


protected:
    void mouseReleaseEvent( QMouseEvent * );
    void drawContents(QPainter *);

private:
    int owner;             // Besitzer 
    int points,maxValue;   // Wert und maximaler Wert des Wrfels
    int row,column;             // Identifikation
    
    static QPalette *color1,*color2;
    static bool clicksAllowed;

};

#endif // Cube_H
















